package com.cours.spring.controller;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javax.validation.Valid;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import com.cours.entities.MyComponentsModel;
import com.cours.entities.Personne;

@Controller
@RequestMapping("/springComponents")
public class SpringComponentsController {

	@RequestMapping("/createComponentsForm")
	public String createComponentsForm(Model model) {
		List<String> listVilles = new ArrayList<String>();
		listVilles.add("Laval");
		listVilles.add("Nantes");
		listVilles.add("Rennes");
		listVilles.add("Paris");
		listVilles.add("Lilles");

		List<String> listPays = new ArrayList<String>();
		listPays.add("France");
		listPays.add("Senegal");
		listPays.add("Angleterre");
		listPays.add("Chine");
		listPays.add("Japon");

		List<Personne> personnes = new ArrayList<Personne>(Arrays.asList(
				new Personne(1, "Maurice", "Dupont", 100.0, 170.0, "rue du paradis", "Rouen", "76000", "France"),
				new Personne(2, "Martin", "Marshall", 55.0, 150.0, "rue de Nantes", "Laval", "53000", "France"),
				new Personne(3, "Claire", "Chazal", 65.0, 175.0, "rue de Rennes", "Laval", "53000", "France"),
				new Personne(4, "Celine", "Dia", 87.0, 170.0, "rue Diderot", "Paris", "75000", "France"),
				new Personne(5, "Remy", "Cheval", 63.0, 140.0, "rue du paradis", "Nantes", "44000", "France"),
				new Personne(6, "Nicolas", "Dutrou", 79.0, 155.0, "rue Appert", "Nantes", "44000", "France"),
				new Personne(7, "Marie", "Claire", 65.0, 166.0, "rue du paradis", "Rouen", "76000", "France"),
				new Personne(8, "Nathalie", "Sage", 89.0, 190.0, "rue Appert", "Rouen", "76000", "France"),
				new Personne(9, "Jean", "Dujardin", 75.0, 140.0, "rue des sorciers", "Havre", "76800", "France"),
				new Personne(10, "Michel", "Leclerc", 89.0, 190.0, "rue du bonneur", "Havre", "76800", "France"),
				new Personne(11, "Julien", "Marshall", 60.0, 145.0, "rue de Nantes", "Laval", "53000", "France"),
				new Personne(12, "Julien", "Claire", 78.0, 170.0, "rue du Paradis", "Paris", "75000", "France"),
				new Personne(13, "Jacques", "Dupont", 63.0, 179.0, "rue des Passeurs", "Paris", "75000", "France"),
				new Personne(14, "Charles", "Hallyday", 100.0, 200.0, "rue des Feugrais", "Rouen", "76000", "France"),
				new Personne(15, "Serge", "Lama", 102.0, 195.0, "rue des Heureux", "Nantes", "44000", "France"),
				new Personne(16, "Vincent", "Thomas", 81.0, 183.0, "rue de Paris", "Rennes", "35000", "France"),
				new Personne(17, "Eric", "Dummat", 61.0, 155.0, "rue de Versaille", "Paris", "75000", "France"),
				new Personne(18, "Nicolas", "Samuel", 64.0, 145.0, "rue de Saint Louis", "Laval", "53000", "France"),
				new Personne(19, "Rémy", "Guerry", 79.0, 191.0, "rue des Sages", "Lyon", "69000", "France"),
				new Personne(20, "Nicolas", "Drapeau", 56.0, 166.0, "rue Mitterrand", "Limoges", "87000", "France"),
				new Personne(21, "Gaelle", "Letourneau", 96.0, 195.0, "rue Jean François", "Rouen", "76000", "France"),
				new Personne(22, "Jacques", "Dupont", 85.0, 179.0, "rue des Anges", "Paris", "75000", "France")));

		MyComponentsModel myComponentsModel = new MyComponentsModel(listVilles, listPays, personnes);
		model.addAttribute("myComponentsModel", myComponentsModel);
		model.addAttribute("listVilles", listVilles);
		model.addAttribute("listPays", listPays);
		model.addAttribute("listPersonnes", personnes);
		return "myFormComponents";
	}

	@RequestMapping(value = "/save", method = RequestMethod.POST)
	public String save(@Valid @ModelAttribute("myComponentsModel") MyComponentsModel myComponentsModel, Model model) {
		System.out.println("myComponentsModel : " + myComponentsModel);

		return "redirect:/";
	}
}
