package com.cours.spring.validators;

import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.Validator;

import com.cours.entities.MyModel;

@Component
public class MyModelValidator implements Validator {

	@Override
	public boolean supports(Class<?> clazz) {
		return MyModel.class.isAssignableFrom(clazz);
	}

	@Override
	public void validate(Object target, Errors errors) {
		if(target instanceof MyModel) {
			MyModel myModel = (MyModel) target;
			if ((myModel.getValue1() == null || "".equals(myModel.getValue1()))) {
					errors.rejectValue("value1", "data.error.value1");
			}
			if ((myModel.getValue2() == null || "".equals(myModel.getValue2()))) {
				errors.rejectValue("value2", "data.error.value2");
			}
		}
	}
}
